


#include "MTK3339.h"

gga gga_parse(char* sentence){
    char* p = sentence;
    gga contents;
    parseTime(p, &contents);
    p = strchr(p, ',') + 1; // parse time with specialized function
    // parse out both latitude and direction, then go to next field, or fail
    parseCoord(p, &contents.latitudeDegrees, 
            &contents.latitude, 
            &contents.latitude_fixed, 
            &contents.lat);
    p = strchr(p, ',') + 1;
    p = strchr(p, ',') + 1;
    // parse out both longitude and direction, then go to next field, or fail
    parseCoord(p, &contents.longitudeDegrees,
            &contents.longitude, 
            &contents.longitude_fixed, 
            &contents.lon);
    p = strchr(p, ',') + 1;
    p = strchr(p, ',') + 1;
    if (!isEmpty(p)) { // if it's a , (or a * at end of sentence) the value is
                       // not included
      contents.fixquality = atoi(p); // needs additional processing
      if (contents.fixquality > 0) {
        contents.fix = 1;
        //lastFix = sentTime;
      } else
        contents.fix = 0;
    }
    p = strchr(p, ',') + 1; // then move on to the next
    // Most can just be parsed with atoi() or atof(), then move on to the next.
    if (!isEmpty(p))
      contents.satellites = atoi(p);
    p = strchr(p, ',') + 1;
    if (!isEmpty(p))
        contents.HDOP = atof(p);
    
    p = strchr(p, ',') + 1;
    if (!isEmpty(p))
      contents.altitude = atof(p);
    p = strchr(p, ',') + 1;
    p = strchr(p, ',') + 1; // skip the units
    if (!isEmpty(p))
      contents.geoidheight = atof(p); // skip the rest
    
    return contents;
}

 uint8_t isEmpty(char *pStart) {
  if (',' != *pStart && '*' != *pStart && pStart != NULL)
    return 0;
  else
    return 1;
}

 uint8_t parseTime(char *p, gga* sentence) {
  
  if (!isEmpty(p)) { // get time    
    uint32_t time = atol(p);
    sentence->hour = time / 10000;
    sentence->minute = (time % 10000) / 100;
    sentence->seconds = (time % 100);
    char *dec = strchr(p, '.');
    char *comstar = minp(strchr(p, ','), strchr(p, '*'));
    if (dec != NULL && comstar != NULL && dec < comstar)
      sentence->milliseconds = atof(p) * 1000;
    else
      sentence->milliseconds = 0;
    
    return 1;
  }
  return 0;
}
 
char* minp(char* a, char* b){
    if(a<b){
        return a;
    }
    else{
        return b;
    }
} 


uint8_t parseCoord(char *pStart, float *angleDegrees,
                              float *angle, int32_t *angle_fixed,
                              char *dir) {
  char *p = pStart;
  if (!isEmpty(p)) {
    // get the number in DDDMM.mmmm format and break into components
    char degreebuff[10];
    char *e = strchr(p, '.');
    if (e == NULL || e - p > 6)
      return 0;                // no decimal point in range
    strncpy(degreebuff, p, e - p); // get DDDMM
    long dddmm = atol(degreebuff);
    long degrees = (dddmm / 100);         // truncate the minutes
    long minutes = dddmm - degrees * 100; // remove the degrees
    p = e;                                // start from the decimal point
    float decminutes = atof(e); // the fraction after the decimal point
    p = strchr(p, ',') + 1;            // go to the next field

    // get the NSEW direction as a character
    char nsew = 'X';
    if (!isEmpty(p))
      nsew = *p; // field is not empty
    else
      return 0; // no direction provided

    // set the various numerical formats to their values
    long fixed = degrees * 10000000 + (minutes * 10000000) / 60 +
                 (decminutes * 10000000) / 60;
    float ang = degrees * 100 + minutes + decminutes;
    float deg = fixed / (float)10000000.0;
    if (nsew == 'S' ||
        nsew == 'W') { // fixed and deg are signed, but DDDMM.mmmm is not
      fixed = -fixed;
      deg = -deg;
    }

    // reject directions that are not NSEW
    if (nsew != 'N' && nsew != 'S' && nsew != 'E' && nsew != 'W')
      return 0;

    // reject angles that are out of range
    if (nsew == 'N' || nsew == 'S')
      if (abs(deg) > 90)
        return 0;
    if (abs(deg) > 180)
      return 0;

    // store in locations passed as args
    if (angle != NULL)
      *angle = ang;
    if (angle_fixed != NULL)
      *angle_fixed = fixed;
    if (angleDegrees != NULL)
      *angleDegrees = deg;
    if (dir != NULL)
      *dir = nsew;
  } else
    return 0; // no number
  return 1;
}

void nmea_chksum(char* sentence,char* command){    
    uint16_t i = 0;
    i = 0;
    uint8_t chksm = 0;
    while(*(command + i)){
        chksm ^= (uint8_t)(*(command + i));
        i++;
    }
    sprintf(sentence,"$%s*%02X\r\n",command,chksm);
}