/* 
 * File:   MTK3339.h
 * Author: mikeb
 *
 * Created on March 3, 2020, 6:45 PM
 */



#ifndef MTK3339_H
#define	MTK3339_H

#include <string.h>
#include <xc.h>
#include <ctype.h>

typedef struct {
    uint8_t hour;
    uint8_t minute;
    uint8_t seconds;
    uint16_t milliseconds;
    
    float latitude;
    float longitude;
    int32_t latitude_fixed;
    int32_t longitude_fixed;
    
    float latitudeDegrees;
    float longitudeDegrees;
    
    float geoidheight;
    float altitude;
    
    float HDOP;
    
    char lat;
    char lon;
    
    uint8_t fix;
    uint8_t satellites;
    
    uint8_t fixquality;
            
} gga;

gga gga_parse(char* sentence);
uint8_t isEmpty(char *pStart);
uint8_t parseTime(char *p, gga* sentence);
char* minp(char* a, char* b);
uint8_t parseCoord(char *, float *,
                              float *, int32_t *,
                              char *);

void nmea_chksum(char* sentence,char* command);

#endif	/* MTK3339_H */

