#include <xc.h>
#include "serial1.h"
#include "SDlib16_LCD.h"

void serial_init1(unsigned long rate){
    // Set up the baud rate
    //unsigned long pbusclk = get_pb_clock();
    unsigned long pbusclk = 80000000;
    U1BRG = pbusclk/(16*rate) - 1;
    // parity and stop bit defaults work, but lets be explicit
    // 8 bit data, no parity, 1 stop bit
    U1MODEbits.STSEL = 0;
    U1MODEbits.PDSEL = 0; // means 00    
    // enable transmit and receive
    U1STAbits.URXEN = 1; // Receiver enabled
    U1STAbits.UTXEN = 1; // transmitter enable
    // turn UART on
    U1MODEbits.ON = 1;
    // ready to transmit and receive!
}

unsigned char getu1(void){
    unsigned char out;
    while(!U1STAbits.URXDA); // wait till there is data available
    // wait until the buffer is full,
    // with nominal 57600 baud rate, 10 ms is plenty
    //delay_ms(10);
    // read in data
    out = U1RXREG;    
    return out;
}

void putu1(unsigned char val){
    while(U1STAbits.UTXBF); // wait for buffer to become available   
    U1TXREG = val;
}

/* USE DIFFERENT UART AS THE PRINTF INTERFACE
void _mon_putc(char c){
    putu1(c);    
}
*/