#include <xc.h>
#include "serial1.h"
#include "SDlib16_LCD.h"

void serial_init2(unsigned long rate){
    // Set up the baud rate
    //unsigned long pbusclk = get_pb_clock();
    unsigned long pbusclk = 80000000;
    U2BRG = pbusclk/(16*rate) - 1;
    // parity and stop bit defaults work, but lets be explicit
    // 8 bit data, no parity, 1 stop bit
    U2MODEbits.STSEL = 0;
    U2MODEbits.PDSEL = 0; // means 00    
    // enable transmit and receive
    U2STAbits.URXEN = 1; // Receiver enabled
    U2STAbits.UTXEN = 1; // transmitter enable
    // turn UART on
    U2MODEbits.ON = 1;
    // ready to transmit and receive!
}

unsigned char getu2(void){
    unsigned char out;
    while(!U2STAbits.URXDA); // wait till there is data available
    // wait until the buffer is full,
    // with nominal 57600 baud rate, 10 ms is plenty
    //delay_ms(10);
    // read in data
    out = U2RXREG;    
    return out;
}

void putu2(unsigned char val){
    while(U2STAbits.UTXBF); // wait for buffer to become available   
    U2TXREG = val;
}


void _mon_putc(char c){
    putu2(c);    
}
