/* 
 * File:   main.c
 * Author: megha
 *
 * Created on February 12, 2020, 7:02 PM
 */

#include <stdio.h>
#include <stdlib.h>
#include <xc.h>
#include "pin_config.h"
#include "i2c5mz.h"
#include "BNO055.h"

// Data divisors
#define EULDIV 16
#define GYRDIV 16
#define MAGDIV 16
#define ACCELDIV 100


int main(int argc, char** argv) {
    
    TRISDbits.TRISD11 = 0;
    LATDbits.LATD11 = 0;
    delay();
    
    // Initialize variables
    Data_BNO data;
    uint8_t addr_w;
    uint8_t addr_r;
    uint8_t read_byte;
    uint8_t config;
    
	// Initialize I2C5
    I2C5_init(4);
    
    // Configure the sensor to run in fusion mode
    config_BNO055();
    
    
    while(1)
    {
        // Read calibration values to ensure sensor is calibrated - Should be 0xFF
        I2C5_start();
        I2C5_write(addr_w);
        I2C5_write(0x35);
        I2C5_stop();

        I2C5_start();
        I2C5_write(addr_r);
        read_byte = I2C5_read(1);
        I2C5_stop();
        
        // Read data
        read_BNO055(&data);
    }
    
    return (EXIT_SUCCESS);
}
