/* 
 * File:   KX222.h
 * Author: zacharykowalczyk
 *
 * Created on February 15, 2020, 8:14 PM
 */

#ifndef KX222_H
#define	KX222_H

#ifdef	__cplusplus
extern "C" {
#endif

#include <xc.h>
    
#define MODE (32)
#define ADDR_W (0x3C)
#define ADDR_R (0x3D)
    
// Struct to store KX222 data
typedef struct
{
    float x_data;
    float y_data;
    float z_data;
} Data_KX;


// Function prototypes
void config_KX222();
void read_KX222(Data_KX*);


void I2C1_init();
void I2C1_start(void);
void I2C1_stop(void);
void I2C1_restart(void);
uint8_t I2C1_write(uint8_t);
uint8_t I2C1_read(int8_t);
void I2C1_ACK(int8_t);


// define Master Interrupt Flag
#define MIF1 IFS3bits.I2C1MIF
#define ACK 0
#define NACK 1

#define READ 0x01
#define WRITE 0x00


#ifdef	__cplusplus
}
#endif

#endif	/* KX222_H */

