/* 
 * File:   i2c3mz.h
 * Author: mikeb
 *
 * Created on February 13, 2020, 7:53 PM
 */

#ifndef I2C3MZ_H
#define	I2C3MZ_H

#include <xc.h>

void I2C3_init(unsigned long rate);
void I2C3_start(void);
void I2C3_stop(void);
void I2C3_restart(void);
uint8_t I2C3_write(uint8_t);
uint8_t I2C3_read(int8_t);
void I2C3_ACK(int8_t);


// define Master Interrupt Flag
#define MIF3 IFS5bits.I2C3MIF
#define ACK 0
#define NACK 1

// TO BE USED WITH A BITWISE OR
#define READ 0x01
#define WRITE 0x00
    
    


#endif	/* I2C3MZ_H */

